const APP_DISPLAY_NAME = "CuteMenus";
const APP_NAME = "cutemenus";
const APP_PACKAGE = "/cute.mozdev.org";
const APP_VERSION = "0.3";

const APP_JAR_FILE = "cutemenus.jar";
const APP_CONTENT_FOLDER = "/";
const APP_THEME_DIR = "CuteMenus Themes"; // theme-directory

const profileChrome = getFolder("Profile", "chrome");
const previousJarInProfile = getFolder(profileChrome, "cutemenus.jar");
const previousJarInRoot = getFolder("chrome", "cutemenus.jar");

var chromef;
var contenttype;
var localetype;
var skintype;
var problemFile = APP_JAR_FILE;


// initialize our install
initInstall(APP_NAME, APP_PACKAGE, APP_VERSION);


// check for previous install
if (File.exists(previousJarInProfile) || File.exists(previousJarInRoot)) {
	
	var installedHere = File.exists(previousJarInProfile)?"profile ":"";
	installedHere += (File.exists(previousJarInProfile) && File.exists(previousJarInRoot))?"*and* ":"";
	installedHere += File.exists(previousJarInRoot)?"root ":"";
	installedHere += (File.exists(previousJarInProfile) && File.exists(previousJarInRoot))?"directories":"directory";

	alert("Sorry:  CuteMenus is already installed in your " + installedHere + ". "
		+"\n\n\n\nYou can update by just replacing the jar-file: "
		+"\nRight-click, save it from the webpage, then search your"
		+"\ncomputer for 'cutemenus.jar'.");
	cancelInstall(); // we can't overwrite, so don't install further
	
}
else {
	
	// check where user wants to install
	if (confirm("Install "+APP_DISPLAY_NAME+" in your profile?\n(..you wont have to reinstall when updating the browser).\n\nClick Cancel to install "+APP_DISPLAY_NAME+" in the browser root.")) {
		chromef = getFolder("Profile", "chrome");
		contenttype = CONTENT | PROFILE_CHROME; } 
	else {
		chromef = getFolder("Chrome");
		contenttype = CONTENT | DELAYED_CHROME; }
	
	
	// install jar-file
	var err = addFile(APP_PACKAGE, APP_VERSION, APP_JAR_FILE, chromef, null);
	
	// install theme-directory
	if (err == SUCCESS) {
		var themeDir = getFolder(chromef, APP_THEME_DIR); // create the theme-directory..
		err = addDirectory(APP_PACKAGE, APP_VERSION, APP_THEME_DIR, themeDir, null); // ..and copy archived-contents into it.
		if (err != SUCCESS) {
			problemFile = APP_THEME_DIR; }
	}
	
	// if we've successfully installed everything, register the jar-file
	if (err == SUCCESS) {
		var jar = getFolder(chromef, APP_JAR_FILE);
		registerChrome(contenttype, jar, APP_CONTENT_FOLDER);
		err = performInstall();
		if (err == SUCCESS)
			alert(APP_DISPLAY_NAME + " " + APP_VERSION + " is now installed.\n" +"Just restart to activate.");
		else { 
			alert("Install failed. Error code:" + err);
			cancelInstall(err); }
	}
	else { 
		alert("Failed to create " +problemFile +"\n"
				+"You probably don't have appropriate permissions \n"
				+"(write access to your profile or chrome directory). \n"
				+"_____________________________\nError code:" + err);
		cancelInstall(err);
	}
}